use File::Copy;

my $extensions_file = $main::pluginconfig{'ivrflow'}{'asterisk_extensions_conf_file'}{''};
my $dialplan = $main::pluginconfig{'ivrflow'}{'dialplan_generator_script'}{''};
my $plugin_path = $main::pluginconfig{'ivrflow'}{'plugin_path'}{''};
my $uid;
my $gid;
(undef, undef, undef, undef, $uid, $gid, undef, undef, undef, undef, undef, undef) = stat ($extensions_file);

if( -f $extensions_file ) {

    if ( -f $dialplan ) {
        open my $fh, '<', $extensions_file;
        my $existe=0;
        while (my $line = <$fh>) {
            if ($line =~ /#exec "php $dialplan"/) {
                $existe=1;
            }
        }
        if ($existe==0) {
            print "IVR FLOW: adding #exec for dynamic dialplan\n";
            open(my $fh, '>>', $extensions_file);
            print $fh "#exec \"php $dialplan\"\n";
            close $fh;
        }
    } else {
        print "IVR FLOW Error: Dialplan generator script $dialplan missing!\n";
    }
} else {
    print "IVR FLOW Error: Asterisk Extension configuration file $extensions_file missing!\n";
}

if(! -f "/var/lib/asterisk/agi-bin/ivrflow.agi") {
    print "IVR FLOW: copying AGI script\n";
    copy("$plugin_path/ivrflow/agi-bin/ivrflow.agi","/var/lib/asterisk/agi-bin/ivrflow.agi");
    chmod 0755, "/var/lib/asterisk/agi-bin/ivrflow.agi";
} else {

    open FILE, "/var/lib/asterisk/agi-bin/ivrflow.agi";
    my $ctx = main::Digest::MD5->new;
    $ctx->addfile(*FILE);
    my $hash1 = $ctx->digest;
    close FILE;

    open FILE, "$plugin_path/ivrflow/agi-bin/ivrflow.agi";
    my $ctx = main::Digest::MD5->new;
    $ctx->addfile(*FILE);
    my $hash2 = $ctx->digest;
    close FILE;

    if($hash1 ne $hash2) {
        print "IVR FLOW: upgrading AGI script\n";
        copy("$plugin_path/ivrflow/agi-bin/ivrflow.agi","/var/lib/asterisk/agi-bin/ivrflow.agi");
        chmod 0755, "/var/lib/asterisk/agi-bin/ivrflow.agi";
    }

}

if(! -f "/var/lib/asterisk/agi-bin/googletts.agi") {
    print "IVR FLOW: copying tts AGI script\n";
    copy("$plugin_path/ivrflow/agi-bin/googletts.agi","/var/lib/asterisk/agi-bin/googletts.agi");
    chmod 0755, "/var/lib/asterisk/agi-bin/googletts.agi";
} else {
    open FILE, "/var/lib/asterisk/agi-bin/googletts.agi";
    my $ctx = main::Digest::MD5->new;
    $ctx->addfile(*FILE);
    my $hash1 = $ctx->digest;
    close FILE;

    open FILE, "$plugin_path/ivrflow/agi-bin/googletts.agi";
    my $ctx = main::Digest::MD5->new;
    $ctx->addfile(*FILE);
    my $hash2 = $ctx->digest;
    close FILE;

    if($hash1 ne $hash2) {
        print "IVR FLOW: upgrading tts AGI script\n";
        copy("$plugin_path/ivrflow/agi-bin/googletts.agi","/var/lib/asterisk/agi-bin/googletts.agi");
        chmod 0755, "/var/lib/asterisk/agi-bin/googletts.agi";
    } 
}

